program Koks(input,output);
{10. Uzrakstt programmu, 
kas auj izveidot binru meklanas koku, 
kura mezglos ir naturli skaiti. 
Skaitlis katr mezgl ir unikls un kalpo par atslgu. 
Uzrakstt procedras, kas auj pievienot jaunu mezglu kokam un izdruk visas atslgas augo secb.}

type 	saite=^elem;
	elem=record
		dati:integer;
		kr:saite;
		lab:saite
		end;
var 	I,N,ElemSk,Dzil,DzilM:integer;
	ID:real;
	C:char;
	Pirm,E:saite;
	koks:file of integer;
	

procedure Atstarpe(a:integer);
	var	X:integer;
	begin
	for X:=1 to a do writeln
	end;


procedure Pievienot(S:saite);
	begin
	E^.kr:=nil;
	E^.lab:=nil;

{Atseviski apluko gadijumu, kad jaizveido koka sakne.}

	if ElemSk=0 then
		begin
		Pirm:=E;
		ElemSk:=1;
		Dzil:=1
		end
	else

{Iesana pa koka zariem, lai atrastu vietu, kur pievienot jauno elementu. Pa
	kreisi, ja elements ir mazaks, pa labi - ja lielaks. paraleli tiek
	noskaidrots koka dzilums.}

		begin
		while (E^.dati<S^.dati)and(S^.kr<>nil)
			or(E^.dati>S^.dati)and(S^.lab<>nil) do
			if (E^.dati<S^.dati) then
				begin
				S:=S^.kr;
				DzilM:=DzilM+1
				end
			else
				begin
				S:=S^.lab;
				DzilM:=DzilM+1
				end;

{Ja sads elements jau eksiste, tiek izvadits atbilstoss pazinojums, preteja
	gadijuma tas tiek pievienots vajadzigaja vieta, un atjaunoti dati par
	koka dzilumu un elementu skaitu.}

		if E^.dati=S^.dati then
			begin
			writeln('Sads elements jau eksiste.');
			read(C)
			end
		else
			begin
			if E^.dati<S^.dati then S^.kr:=E
			else S^.lab:=E;
			ElemSk:=ElemSk+1;
			if DzilM+2>Dzil then Dzil:=DzilM+2
			end
		end;
	end;


procedure Apskatit;
	var 	pKoks:array[1..31]of saite;
		N,G,X:integer;
	function DP(X:integer):integer;
		begin
		if X=0 then DP:=1
		else DP:=DP(X-1)*2
		end;
	begin
	Atstarpe(25);
	X:=2;
	pKoks[1]:=Pirm;

{Koks tiek izvietots masiva lidzigi, ka to dara ar pabeigtiem kokiem.}

	for N:=1 to 15 do
		if pKoks[N]=nil then
			begin
			pKoks[X]:=nil;
			pKoks[X+1]:=nil;
			X:=X+2
			end
		else
			begin
			pKoks[X]:=pKoks[N]^.kr;
			pKoks[X+1]:=pKoks[N]^.lab;
			X:=X+2
			end;

{No masiva pa dziluma limeniem tiek nolasitas virsotnu vertibas un izvaditas
	uz ekrana. Neizmantotas virsotnes apzimetas ar "*".}

	X:=1;
	for N:=0 to Dzil-1 do
		begin
		for G:=1 to DP(N) do
			begin
			if pKoks[X]=nil then write('*':85 div(DP(N)+1)-1)
			else write(pKoks[X]^.dati:85 div(DP(N)+1)-1);
			if (G mod 2)=0 then write(' ');
			X:=X+1
			end;
		Atstarpe(2)
		end;
	read(C);
	Atstarpe(25)
	end;


{N. Virta algoritms elementa dzesanai binara koka.}

procedure Dzest(var d:saite;k:integer);
	var	q:saite;
	procedure Dz(var r:saite);
		begin
		if r^.lab=nil then
			begin
			q^.dati:=r^.dati;
			q:=r;
			r:=r^.kr
			end
		else Dz(r^.lab)
		end;
	begin

{Iespejami 3 dazadi gadijumi: virsotnes ar sadu vertibu nemaz nav; virsotnei ir ne vairak ka viens berns
	un virsotnei ir tiesi divi berni.}

	if d=nil then
		begin
		writeln('Sads elements neeksiste.');
		read(C)
		end
	else
		if k<d^.dati then Dzest(d^.kr,k)
		else
			if k>d^.dati then Dzest(d^.lab,k)
			else
				begin
				q:=d;
				if q^.lab=nil then d:=q^.kr
				else
					if q^.kr=nil then d:=q^.lab
					else Dz(q^.kr)
				end
	end;


{Dati no atminas tiek parsutiti uz failu un koks iznicinats.}

procedure Aizvert(S:saite);
	begin
	if S<>nil then
		begin
		write(koks,S^.dati);
		Aizvert(S^.kr);
		if S^.kr<>nil then dispose(S^.kr);
		Aizvert(S^.lab);
		if S^.lab<>nil then dispose(S^.lab)
		end
	end;


{Koka virsotnu vertibas tiek izdrukatas augosa seciba saskana ar inorder.}

procedure Izdrukat(S:saite);
	begin
	if S<>nil then
		begin
		Izdrukat(S^.kr);
		writeln(S^.dati);
		Izdrukat(S^.lab)
		end
	end;


procedure Atvert;
	begin
	reset(koks);
	ElemSk:=0;
	Dzil:=0;
	while not EOF(koks) do
		begin
		new(E);
		read(koks,E^.dati);
		DzilM:=0;
		Pievienot(Pirm);
		E:=nil
		end;
	close(koks)
	end;


begin

{ Programmas intro}

	Atstarpe(5);
	writeln('Laboratorijas darbs 4.10');
	writeln('Gatis MEDNIS, LU FMF 1DZ3, 22.05.1998.');
	Atstarpe(1);
	write('Programma apstrada binaru meklesanas koku, kuram ka atslegas ');
	writeln('tiek izmantoti');
	writeln('naturali skaitli. Pieejamas sadas operacijas:');
	writeln('	> pievienot elementu,');
	writeln('	> apskatit koku (ja dzilums neparsniedz 5),');
	writeln('	> dzest elementu,');
	writeln('	> beigt darbu,');
	writeln('	> izdrukat elementus augosa seciba.');

{Dati no faila tiek ielasiti atmina un ievietoti koka.}
	Atvert;

	
{Izvelne.}

	repeat
	Atstarpe(2);
	writeln('	Elementu skaits:	',ElemSk:1);
	writeln('	Koka dzilums:		',Dzil:1);
	Atstarpe(1);
	writeln('	1-Pievienot elementu.');
	writeln('	2-Apskatit koku.');
	writeln('	3-Dzest elementu.');
	writeln('	4-Beigt darbu.');
	writeln('	5-Izdrukat augosa seciba.');
	Atstarpe(1);
	write('Izvelieties 1-5! ');
	readln(I);
	
{Tiek ievadita jauna elementa vertiba(tai jabut naturalam skaitlim) un izsaukta
	pievienosanas procedura.}

	if I=1 then
		begin
		Atstarpe(25);
		new(E);
		ID:=-1;
		write('Ievadiet naturalu skaitli! ');
		while (E^.dati<>ID) do
			begin
			readln(ID);
			if (ID=trunc(ID))and(ID>=0) then E^.dati:=trunc(ID)
			else
				begin
				Atstarpe(1);
				writeln('Nekorekti ievaddati.'); 
				write('Ievadiet NATURALU skaitli! ');
				end
			end;
		Atstarpe(2);
		DzilM:=0;
		Pievienot(Pirm);
		E:=nil;
		Atstarpe(25)
		end;

{Parejo proceduru izsauksana.}

	if (I=2)and(Dzil>0)and(Dzil<6) then Apskatit;
	if (I=3)and(ElemSk>0) then
		begin
		Atstarpe(25);
		ID:=-1;
		write('Ievadiet ta elementa vertibu, kuru gribat dzest! ');
		while (N<>ID) do
			begin
			readln(ID);
			if (ID=trunc(ID))and(ID>=0) then N:=trunc(ID)
			else
				begin
				Atstarpe(1);
				writeln('Nekorekti ievaddati.'); 
				write('Ievadiet NATURALU skaitli! ');
				end
			end;
		Atstarpe(2);
		Dzest(Pirm,N);
		Atstarpe(25);
		rewrite(koks);
		Aizvert(Pirm);
		if Pirm<>nil then dispose(Pirm);
		close(koks);
		Atvert;
		Apskatit
		end;
	if (I=5)and(ElemSk<>0) then
		begin
		Atstarpe(25);
		Izdrukat(Pirm);
		read(C);
		Atstarpe(25)
		end;
	until I=4;
	
{Datu saglabasana un darba beigas.}

	rewrite(koks);
	Aizvert(Pirm);
	if Pirm<>nil then dispose(Pirm);
	close(koks);

	Atstarpe(2);
	writeln('Beigas.');
	Atstarpe(5)
end.
