
uses crt;

{Definejam tipu, kura ir divi lauki:
                                    - datu
                                    - raditajs
}
type
     nameLink = ^nameList;
     nameList = record
                DATA: integer;
                Next: nameLink;
                end;
label izeja;
var vNode, { darba raditajs, ar kura palidzibu definejam katru saraksta el}
    base,  { lietotaja ievadito datu saraksta pirma el raditajs}
    basePara, { radidajs uz para skaitlu saraksta pirmo elementu

    { raditajs uz para skaitlu saraksta pirmo elementu}
    baseNepara: nameLink;

    { mainigais, kas satur lietotaja izveletas komandas kartas numuru}
    ch: char;

procedure addNode( vStr: integer; var vBase: nameLink);
{ Pievieno noraditajam sarakstam elementu }

var
    { Raditajs, kurs norada uz tekoso saraksta elementu}
    vCurNode: nameLink;

begin
    { Ja saraksts uz tuks ... }
    if vbase = nil then begin
       { Izveido saraksta pirmo elemntu }
       new( vNode );

       { Elementa laukaa DATA ieraksta konkreto skaitli }
       vNode^.data := vStr;

       { Elementa laukaa NEXT ieraksta tuksu adresi,
         kas nozime, ka elements ir pedejais sarakstaa }
       vNode^.next := nil;

       { Iestada saknes raditaju, uz saraksta pirmo elementu }
       vBase := vNode;
       end
    else begin
        { Nostada darba raditaju uz saraksta pirmo elemntu }
        vCurNode := vBase;

        { Atkarto ciklu, kamer ir sasniegts saraksta pedejais elements}
        while vCurNode^.next <> nil do begin
              { Iestada darba raditaju uz saraksta nakoso elementu}
              vCurNode := vCurNode^.next;
        end;

        { Izveido jaunu saraksta elementu}
        new( vNode );

        { Saraksta pedeja elementa laukaa NEXT ieraksta
          tikko izveidota elementa adresi,
          isak sakot -  sarakstam pieliek klat jaunizveidoto elementu }
        vCurNode^.next := vNode;


        { Ieraksta tikko izveidotaja elementa laukaa DATA konkreto vertibu }
        vNode^.data := vStr;

        { Ieraksta tikko izveidotaja elementa laukaa NEXT tuksu adresi }
        vNode^.next := nil;
    end;

end;

{ Izdrukaa noraditaa saraksta elementu vertibas uz ekraanu }
procedure printList( base: nameLink );
var curNode: nameLink;
begin
   if base = nil then
      writeln( 'Tukss saraksts')
   else begin
        { Iestada darba raditaju uz saraksta pirmo elementu }
        curNode := base;

        { Parbida darba raditaju pa saraksta visiem elementiem
          un apstajas uz pedejo saraksta elemntu }
        while curNode^.next <> nil do begin
              writeln( curNode^.data );
              curNode := curNode^.next;
        end;
        { Izdruka arii pedejo saraksta elementu }
        writeln( curNode^.data );

   end;
end;

procedure delList( var vBase: nameLink);
var saveNode, curNode: nameLink;

begin
   curNode := vbase;
   saveNode := vbase;

   { Ja saraksts ir netuks, ... }
   if vbase <> nil then begin
      { Izpilda ciklu, kamer nav sasniegts saraksta pedejais elements }
      while curNode^.next <> nil do begin

         { Atceras bernelja adresi, kura sez fateriisja kabataa }
         saveNode := curNode^.next;

         { Iznicina fateri }
         dispose( curNode );

         { Fikse uzmanibu uz bernela iznicinasanu }
         curNode := saveNode;
      end;
      dispose( curNode );
   end;
   vbase := nil;
   { Piezime katram faterim var but tikai, viens berns, viens mazberns, ... }
end;

procedure PrintMenu;
begin

{ Izdrukaa komandu menuci }
writeln;
writeln('1. Pievienot elementu');
writeln('2. Dzest sarakstu');
writeln('3. Izveidot paru sk sarakstu un nep');
writeln('-------------------------------------');
writeln('4. Beigt');
writeln('Jusu izvele ?');

end;

{ Lietotajs ievada jaunu saraksta elementu }
procedure getInput;
label cikls;
var
    ch: char; { mainigais, kas satur lietotaja ievadito vertibu }
    vNum, code: integer;
begin
  cikls:

  writeln('Ievadiet ciparu 0..9');
  readln(ch);
  if (ord( ch ) < 48) or (ord( ch ) > 57) then begin
     { Ja operators akstaas, tad to piefikse uz ekraana }
     writeln('Ievade ir kludaina, ievadiet velreiz ciparu 0..9');
     goto cikls;
  end;

  { Konverte Char vertibu => Numeric}
  val( ch,vNum, code );

  { Pievieno sarakstam lietotaja ievadito elemntu }
  addNode( vNum, base );
end;


procedure createLists;
{ Izveido nepara un para skaitlu sarakstu, no dota saraksta}

var curNode: nameLink;
begin

   { Iznicina paru skaitlu sarakstu }
   delList( basePara );

   { Tas pats notiek ar nepara skaitlu sarakstu }
   delList( baseNePara );

   { Ja dotais saraksts ir netuss, ... }
   if base <> nil then begin
      { Iestada darba raditaju uz saraksta sakumu }
      curNode := base;

      { Pastaigajas pa saraksta elementiem, nonakot lidz pedejam }
      while curNode^.next <> nil do begin

         { Izraadaas, ka tekosam saraaksta elementam
          piemiit ipasiba dalities bez atlikuma ar 2 }
         if curNode^.data mod 2 = 0 then
            addNode( curNode^.data, basePara )

        { Soreiz gan nebuusim tik optimistiski,
          un samierinasimies ar to, ka tekosajam saraksta
          elemnetam sjii briiniskjiigaa ipasjiiba nepiemiit }
         else
            addNode( curNode^.data, baseNePara );
         curNode := curNode^.next;
      end;

         { Atseviski parbaudam vai BUUT para skaitlim }
         if curNode^.data mod 2 = 0 then
            addNode( curNode^.data, basePara )

         { vai NEBUT }
         else
            addNode( curNode^.data, baseNePara );

         { Izvadam paru skaitlu sarakstu uz stream - DISPLAY }
         writeln('Paru skaitlu lists');
         printList( basePara );
         writeln;

         { Lieki atkartosos, bet taads liktenis piemekle ari
           nepara skaitlus }
         writeln('Neparu skaitlu lists');
         printList( baseNePara );
         writeln('Spied Ctrl+Reset');
         ch := readkey;
         { Ja padoms ir uzklausits, tad talak var nelasit, nepeetiit,
           jo programma uzkaraas }

   end;

end;

{ Abstrakcija ir beigusies, sakas programmas Body }
begin

  { Pievieno sarakstam divus elemntus (tas naak kaa mazs prezents) }
  addNode( 1, base );
  addNode( 2, base );

  { Sakas muuziigais cikls (slikta programmesanas pazime) }
  repeat
  { Saisinajums no TiritEkranu }
  clrscr;
  printList( base );
  printMenu;

  { Gaida no lietotaja ievades reakciju }
  ch := readkey;

  { Analize lietotaja nospiesto taustinu }
  case ch of
  '1': getInput;
  '2': delList( base );
  '3': createLists;
  '4': goto izeja; { Kapjam aaraa no garlaiciigaa cikla }
  end;
  until 1=2;

  izeja:

  { Peec vecaaku paveles iznesam miskasti kopa ar vecaakiem,
    neaizmirstot to,
    ka pashi arii tur ielecam, ar sencu piisljiem }

  delList( base );
  delList( basePara );
  delList( baseNePara );

end.
