program Saraksts(input,output);
{9. Uzrakstt funkciju vai procedru, 
kas saraksta n-tajam elementam pieir m-t elementa vrtbu 
un m-to elementu izncina}

type 	saite=^elem;
	elem=record
		dati:integer;
		nak:saite;
		iepr:saite
	end;
var 	I:integer;
	C:char;
	Pirm:saite;

{Programma tiks izmantots divvirzienu saraksts, kura 'galvina' glabasies 
	norades uz saraksta pirmo un pedejo elementu, ka ari elementu
	skaits.}

procedure Atstarpe(a:integer);
	var	X:integer;
	begin
	for X:=1 to a do writeln
	end;

procedure Pievienot;
	var	ID:real;
		E:saite;
	begin
	Atstarpe(25);

{Pieveinojama elementa vertibas ievade - tai ir jabut veselam skaitlim.}

	write('Ievadiet ',Pirm^.dati+1:1,'. elementa vertibu - veselu skaitli! ');
	readln(ID);
	while (ID<>trunc(ID)) do
		begin
		Atstarpe(1);
		writeln('Nekorekti ievaddati.'); 
		write('Ievadiet VESELU skaitli! ');
		readln(ID)
		end;

{Tiek atrasts pedejais saraksta elements un izveidots tam sekojosais
	elements.}

	E:=(Pirm^.iepr);
	new(E^.nak);

{Tiek pieskirti pedeja elementa atributi - skaitliska vertiba un norade uz
	ieprieksejo elementu.}

	E^.nak^.dati:=trunc(ID);
	E^.nak^.iepr:=E;

{Tiek atjaunoti saraksta pamatdati - norade uz pedejo elementu un elementu
	skaits.}

	Pirm^.iepr:=E^.nak;
	Pirm^.dati:=Pirm^.dati+1;
	Atstarpe(25)
	end;
	
procedure Apskatit;
	var 	N:integer;
		E:saite;
	begin

{Visi saraksta elementi tiek izdrukati soli pa solim sakot no 1.}

	Atstarpe(25);
	writeln('	  Nr.	    Dati');
	writeln('	__________________');
	Atstarpe(1);
	E:=Pirm^.nak;
	for N:=1 to Pirm^.dati do
		begin
		writeln(N,'.',E^.dati);
		E:=E^.nak
		end
	end;
	
procedure Iznicinat;
	var	N:integer;
		X:saite;
	begin

{Tiek atrasts saraksta pedejais elements, pec tam atkartoti tiek izpilditas
	darbibas 'pakapties atpakal' un 'iznicinat nakoso elementu'.}

	X:=Pirm^.iepr;
	for N:=1 to Pirm^.dati do
		begin
		X:=X^.iepr;
		dispose(X^.nak)
		end;

{Tiek iznicinats 'galvinas' elements.}

	dispose(Pirm)
	end;

procedure FX;
	var	LS,MS,N:integer;
		S,M:real;
		X1,X2,X3:saite;
	begin

{Tiek izdrukats apskatei saraksts un ievaditi to elementu numuri, kuriem
	tiks pielietota procedura. Ievadatiem jabut veseliem skaitliem
	intervala 1...n, kur n - saraksta elementu skaits; tie nedrikst
	sakrist.}

	Apskatit;
	Atstarpe(2);
	write('Ievadiet iznicinama elementa numuru! ');
	readln(S);
	while (S<>trunc(S))or(S<1)or(S>Pirm^.dati) do
		begin
		Atstarpe(1);
		writeln('Nekorekti ievaddati.'); 
		write('Ievadiet skaitli 1-',Pirm^.dati:1,'! ');
		readln(S)
		end;
	Atstarpe(2);
	writeln('Ievadiet ta elementa numuru, kuram velaties pieskirt ',trunc(S):1,'. elementa');
	write('vertibu! ');
	readln(M);
	while (M<>trunc(M))or(M<1)or(M>Pirm^.dati)or(M=S) do
		begin
		Atstarpe(1);
		writeln('Nekorekti ievaddati.'); 
		write('Ievadiet skaitli 1-',Pirm^.dati:1,'! ');
		readln(M)
		end;

{Tiek noskaidrots lielakais un mazakais numurs. tas nepieciesams talakas
	apstrades algoritmam.}

	if S>M then
		begin
		LS:=trunc(S);
		MS:=trunc(M)
		end
	else
		begin
		LS:=trunc(M);
		MS:=trunc(S)
		end;
	X3:=Pirm;

{Lai butu japarlasa pec iespejas mazak saraksta elementu, kas ir svarigi pie
	liela datu daudzuma, tiek salidzinats, vai elements ar mazako numuru
	ir tuvak saraksta beigam vai ari elements ar lielako numuru -
	saraksta sakumam. Attiecigi nepieciesamo norazu meklesana notiks vai
	nu no sakuma vai no beigam. Ja abi 'celi' ir vienada garuma, meklets
	tiks no sakuma.
	X1 - elements, kurs jaiznicina,
	X2 - elements, uz kura eksportes X1 vetibu.}

	if LS<Pirm^.dati-MS+2 then
		begin
		for N:=1 to MS do X3:=X3^.nak;
		if S<M then X1:=X3
		else X2:=X3;
		for N:=MS+1 to LS do X3:=X3^.nak;
		if S<M then X2:=X3
		else X1:=X3
		end
	else
		begin
		for N:=Pirm^.dati downto LS do X3:=X3^.iepr;
		if S<M then X2:=X3
		else X1:=X3;
		for N:=LS-1 downto MS do X3:=X3^.iepr;
		if S<M then X1:=X3
		else X2:=X3
		end;

{Vispirms parsuta skaitlisko vertibu, pec tam izveido norades uz ieprieksejo
	(X2) un nakoso (X3) iznicinama elementa vertibu.}

	X2^.dati:=X1^.dati;
	X2:=X1^.iepr;
	X3:=X1^.nak;

{Ja iznicinamais elements nav pedejais saraksta, tad ta nakosajam izmaina
	noradi uz ieprieksejo, citadi mainas norade uz pedejo saraksta
	elementu.}

	if trunc(S)<>Pirm^.dati then X3^.iepr:=X2
	else Pirm^.iepr:=X2;

{Iznicina vajadzigo elementu.}

	dispose(X2^.nak);

{Korige noradi uz nakoso elementu un samazina sraksta elementu skaitu.}

	X2^.nak:=X3;
	Pirm^.dati:=Pirm^.dati-1
	end;
	

begin

{ Programmas intro}

	Atstarpe(5);
	writeln('Laboratorijas darbs 1.9');
	writeln('Gatis MEDNIS, LU FMF 1DZ3, 13.03.1998.');
	Atstarpe(1);
	write('Programma lauj izveidot sarakstu, kura glabajas veseli skaitli.');
	writeln(' Lietotajam');
	writeln('pieejamas sadas operacijas:');
	writeln('	> pievienot sarakstam elementu,');
	writeln('	> izdrukat sarakstu,');
	writeln('	> iznicinat sarakstu,');
	write('	> saraksta n-tajam elementam pieskirt m-ta elementa vertibu');
	writeln(' un iznicinat');
	writeln('	m-to elementu.');

	repeat

{Izveido saraksta 'galvinu'.}

	new(Pirm);
	Pirm^.dati:=0;
	Pirm^.iepr:=Pirm;
	
	repeat

{Izvelne.}

	Atstarpe(2);
	writeln('	Elementu skaits: ',Pirm^.dati:1);
	Atstarpe(1);
	writeln('	1-Pievienot elementu.');
	writeln('	2-Apskatit sarakstu.');
	writeln('	3-Iznicinat sarakstu.');
	writeln('	4-FX.');
	Atstarpe(1);
	write('Izvelieties 1-4! ');
	readln(I);
	if I=1 then Pievienot;
	if I=2 then Apskatit;

{Specialo proceduru iespejams izpildit tikai tad, ja saraksta ir vismaz divi
	elementi.}

	if (I=4)and(Pirm^.dati>1) then FX;
	until I=3;
	Iznicinat;

{Programma paredz iespeju atkartoti veidot sarakstu. Pirms tam atmina tiek
	atbrivota no ieprieksejiem datiem.}

	Atstarpe(2);
	write('Izveidot jaunu sarakstu (J/N)? ');
	readln(C);
	while (C<>'j')and(C<>'J')and(C<>'n')and(C<>'N') do
		begin
		Atstarpe(1);
		writeln('Nekorekti ievaddati.'); 
		write('Izveidot jaunu sarakstu (J/N)? ');
		readln(C)
		end;
	until (C='n')or(C='N');
	Atstarpe(2);
	writeln('Beigas.');
	Atstarpe(5)
end.
