program Datums(input,output);
{10. Uzrakstt programmu, 
kas auj izveidot un labot failu, 
kur glabjas datumi un kura ieraksta struktra ir sekojoa: 
gads (integer), mnesis (integer), diena (integer), ieraksta statuss (boolean). 
Programmai katrs jauns ieraksts jieliek faila beigs. 
Ja fail tds datums jau eksist, tas nav jpieliek. 
Jparedz iespja izmest faila komponenti (loiski atzmjot k izmestu), 
izdrukt fail esoos datumus uz ekrna, izmest loiski izmestas komponentes fiziski.}

type 	ieraksts=record
		gads,menesis,diena:integer;
		statuss:boolean
		end;
	saite=^elem;
	elem=record
		gads,menesis,diena:integer;
		statuss:boolean;
		nak:saite;
		iepr:saite
		end;
var 	I:integer;
	C:char;
	X:ieraksts;
	Pirm,E:saite;
	dati:file of ieraksts;
	Menesis:array [1..12] of integer;

{Fails tiks ieladets atmina un apstradats ka saraksts. Pec darba beigam tas
	tiks atkal parveidots rakstu faila.}

procedure Atstarpe(a:integer);
	var	X:integer;
	begin
	for X:=1 to a do writeln
	end;

procedure Pievienot;
	var	ID:real;
		S:boolean;
		A,E:saite;
	begin
	Atstarpe(25);

{Pievienojama ieraksta vertibu ievade.}

	writeln('Ievadiet ',Pirm^.gads+1:1,'. elementa vertibu! ');
	write('	Gads: ');
	readln(ID);
	while (ID<>trunc(ID))or(ID<-8000)or(ID>2100) do
		begin
		Atstarpe(1);
		writeln('Nekorekti ievaddati.'); 
		write('Ievadiet VESELU skaitli (-8000...2100)! ');
		readln(ID)
		end;
	X.gads:=trunc(ID);

{Tiek noskaidrots kads ir maksimali pielaujamais februara dienu skaits}

	if X.gads/4=trunc(X.gads/4) then Menesis[2]:=29
	else Menesis[2]:=28;
	
	write('	Menesis: ');
	readln(ID);
	while (ID<>trunc(ID))or(ID<1)or(ID>12) do
		begin
		Atstarpe(1);
		writeln('Nekorekti ievaddati.'); 
		write('Ievadiet VESELU skaitli (1...12)! ');
		readln(ID)
		end;
	X.menesis:=trunc(ID);
	write('	Diena: ');
	readln(ID);
	while (ID<>trunc(ID))or(ID<1)or(ID>Menesis[X.menesis]) do
		begin
		Atstarpe(1);
		writeln('Nekorekti ievaddati.'); 
		write('Ievadiet VESELU skaitli (1...',Menesis[X.menesis]:1,')! ');
		readln(ID)
		end;
	X.diena:=trunc(ID);

{Tiek parbaudits, vai faila jau eksiste sads ieraksts.}

	E:=Pirm;
	S:=false;
	while ((E^.gads<>X.gads)or(E^.menesis<>X.menesis)or(E^.diena<>X.diena))
		and(E^.nak<>nil) do E:=E^.nak;

{Ja parbaudes beigas mainigais E norada uz pedejo elementu un tas nesakrit
	ar ievadito, var sakt ieraksta pievienosanu.}
		
	if (E^.nak=nil)and((E^.gads<>X.gads)or(E^.menesis<>X.menesis)
		or(E^.diena<>X.diena)) then S:=true

{Ja faila jau eksiste sads elements, bet ta statuss ir FALSE, tad var
	izveleties: atjaunot esoso vai pievienot no jauna. Pedeja gadijuma
	esosais elements tiks izdzests, lai nerastos konflikts pie
	iespejamajam statusa izmainam.}

	else	if E^.statuss=false then
			begin
			write('Atjaunot esoso ierakstu (J/N)? ');
			readln(C);
			while (C<>'j')and(C<>'J')and(C<>'n')and(C<>'N') do
				begin
				Atstarpe(1);
				writeln('Nekorekti ievaddati.'); 
				write('Atjaunot esoso ierakstu (J/N)? ');
				readln(C)
				end;
			if (C='j')or(C='J') then E^.statuss:=true
			else
				begin
				A:=E^.nak;
				E:=E^.iepr;
				dispose(E^.nak);
				E^.nak:=A;
				if A<>nil then A^.iepr:=E
				else Pirm^.iepr:=E;
				Pirm^.gads:=Pirm^.gads-1;
				S:=true
				end
			end

{Ja faila jau eksiste sads elements, un ta statuss ir TRUE, tad programma
	izdod atbilstosu pazinojumu.}

		else
			begin
			writeln('Ieraksts jau eksiste.');
			read(C)
			end;
	
{Tiek pievienots ieraksts - pieskirtas vertibas un atjaunotas saraksta
	norades.}

	if S then
		begin
		E:=(Pirm^.iepr);
		new(E^.nak);
		Pirm^.gads:=Pirm^.gads+1;
		E^.nak^.gads:=X.gads;
		E^.nak^.menesis:=X.menesis;
		E^.nak^.diena:=X.diena;
		E^.nak^.statuss:=true;
		E^.nak^.iepr:=E;
		Pirm^.iepr:=E^.nak
		end;
	Atstarpe(25)
	end;
	
procedure Apskatit;
	var 	N:integer;
		E:saite;
	begin

{Pec kartas tiek izdrukati visi faila ieraksti.}

	Atstarpe(25);
	writeln('	  Nr.	       Datums	       Statuss');
	writeln('	________________________________________');
	Atstarpe(1);
	E:=Pirm^.nak;
	for N:=1 to Pirm^.gads do
		begin
		writeln(N,'.',E^.diena,'.',E^.menesis:1,'.',E^.gads:1,'.',E^.statuss);
		E:=E^.nak
		end
	end;
	
procedure Aizvert;
	var	N:integer;
		E:saite;
	begin

{Tiek atjaunota informacija - visi ieraksti, kuru statuss ir TRUE tiek
	ierakstiti faila.}

	rewrite(dati);
	E:=Pirm^.nak;
	Pirm^.iepr^.nak:=Pirm;
	for N:=1 to Pirm^.gads do
		begin
		if E^.statuss=true then
			begin
			X.gads:=E^.gads;
			X.menesis:=E^.menesis;
			X.diena:=E^.diena;
			X.statuss:=true;
			write(dati,X)
			end;		
		E:=E^.nak;
		dispose(E^.iepr)
		end;

{Tiek iznicinats 'galvinas' elements.}

	dispose(Pirm);
	close(dati)
	end;

procedure Statuss;
	var	N:integer;
		S:real;
		X:saite;
	begin

{Tiek izdrukats apskatei fails}

	Apskatit;
	Atstarpe(2);
	write('Ievadiet ta ieraksta numuru, kuram mainisiet statusu: ');
	readln(S);
	while (S<>trunc(S))or(S<1)or(S>Pirm^.gads) do
		begin
		Atstarpe(1);
		writeln('Nekorekti ievaddati.'); 
		write('Ievadiet skaitli 1-',Pirm^.gads:1,'! ');
		readln(S)
		end;
	Atstarpe(2);

{Tiek atrasts ieraksts un manits ta statuss.}

	X:=Pirm;
	for N:=1 to trunc(S) do X:=X^.nak;
	X^.statuss:=not(X^.statuss)
	end;
		
	

begin

{ Programmas intro}

	Atstarpe(5);
	writeln('Laboratorijas darbs 3.10');
	writeln('Gatis MEDNIS, LU FMF 1DZ3, 30.04.1998.');
	Atstarpe(1);
	write('Programma apstrada datumu failu ar strukturu: gads, menesis, ');
	writeln('diena, ieraksta');
	writeln('statuss. Pieejamas sadas operacijas:');
	writeln('	> pievienot ierakstu,');
	writeln('	> izdrukat failu,');
	writeln('	> aizvert failu (likvidejot dzestos ierakstus),');
	writeln('	> mainit ieraksta statusu');

{Tiek pieskirtas vertibas masivam, kura glabajas maksimali pielaujamais
	dienu skaits menesi.}

	Menesis[1]:=31;
	Menesis[2]:=28;
	Menesis[3]:=31;
	Menesis[4]:=30;
	Menesis[5]:=31;
	Menesis[6]:=30;
	Menesis[7]:=31;
	Menesis[8]:=31;
	Menesis[9]:=30;
	Menesis[10]:=31;
	Menesis[11]:=30;
	Menesis[12]:=31;

{Dati no faila tiek ielasiti atmina un ievietoti saraksta.}

	reset(dati);
	new(Pirm);
	Pirm^.gads:=0;
	E:=Pirm;
	while not EOF(dati) do
		begin
		read(dati,X);
		new(E^.nak);
		E^.nak^.iepr:=E;
		E:=E^.nak;
		E^.gads:=X.gads;
		E^.menesis:=X.menesis;
		E^.diena:=X.diena;
		E^.statuss:=true;
		Pirm^.gads:=Pirm^.gads+1
		end;
	Pirm^.iepr:=E;
	close(dati);
	
	repeat

{Izvelne.}

	Atstarpe(2);
	writeln('	Elementu skaits: ',Pirm^.gads:1);
	Atstarpe(1);
	writeln('	1-Pievienot ierakstu.');
	writeln('	2-Apskatit failu.');
	writeln('	3-Aizvert failu.');
	writeln('	4-Mainit ieraksta statusu.');
	Atstarpe(1);
	write('Izvelieties 1-4! ');
	readln(I);
	if I=1 then Pievienot;
	if I=2 then Apskatit;


	if (I=4)and(Pirm^.gads>0) then Statuss;
	until I=3;
	Aizvert;

	Atstarpe(2);
	writeln('Beigas.');
	Atstarpe(5)
end.
